#include "dist.h"

DISTMAP::DISTMAP() : myDist(-2)
{
}

DISTMAP::DISTMAP(POS p) : myDist(-2)
{
    build(p, 20);
}

DISTMAP::~DISTMAP()
{
}

void
DISTMAP::build(POS p, int maxdist)
{
    POSLIST		stack;
    DIR			dir;

    myDist.clear(-2);
    stack.append(p);
    myDist.setValue(p, 0);

    while (stack.entries())
    {
	int	d;
	p = stack.removeFirst();
	d = myDist.value(p);

	if (d >= maxdist)
	    break;

	FORALL_DIR(dir)
	{
	    POS	n = p.delta(dir);
	    if (!n.valid())
		continue;

	    if (!n.defn().passable)
		continue;

	    int	nd = myDist.value(n);
	    if (nd >= 0)
		continue;

	    myDist.setValue(n, d+1);
	    stack.append(n);
	}
    }
}

bool
DISTMAP::grad(POS p, DIR &d) const
{
    if (!p.valid())
	return false;

    int pd = myDist.value(p);
    DIR dir;
    bool found = false;
    FORALL_DIR(dir)
    {
	int npd = myDist.value(p.delta(dir));
	if (npd >= 0 && (pd < 0 || npd < pd))
	{
	    pd = npd;
	    d = dir;
	    found = true;
	}
    }
    return found;
}
