#pragma once

#include "glbdef.h"
#include "buf.h"

#include <string.h>

#define MAX_RUNELEN 6

class RUNEWORD
{
public:
    RUNEWORD() { memset(runes, 0, MAX_RUNELEN); }
    BUF			buildRune() const;
    int			usageMask() const;

    u8			runes[MAX_RUNELEN];
};

class RUNES
{
public:
    RUNES();
    ~RUNES();

    void		init();

    BUF			spellRune(SPELL_NAMES spell) const;
    BUF			riddleRune() const;

    SPELL_NAMES		findSpell(const char *s) const;
    SPELL_NAMES		findSpell(BUF buf) const
    { return findSpell(buf.buffer()); }

    static RUNES	*getRunes();

protected:
    RUNEWORD		mySpell[NUM_SPELLS];
    RUNEWORD		myRiddle;
};

